
from Multipack import *
from Numeric import *
from umath import *
from MLab import *
from basics import *
from FFT import *
from FITS import *
from TwistedClient import *
import sys

def trim(data,c1,c2,d1,d2):
      o=transpose(data[::,c1:c2+1])
      b = bwt(o)[0]
      data = subtract(data,b[::,NewAxis])
      return data[::,d1:d2].astype(Float32)

def BiasChip(input,output,fno):
   outbitpix=-32
   print 'Frame #%d' % (fno+1)
   F=FITS(input)
   exptime = F["exptime"]
   data=F.readframe(fno+1)
   naxes = F.naxes()
   sec = F["DETSEC"]
   F.close()
   data=data.astype(Float64)
   xd1,xd2 = 12,2060
   overscan = naxes[0] - xd2
   xc1,xc2 = xd2,xd2+overscan

   data = trim(data,xc1,xc2,xd1,xd2)

   sx,sy = sec.split(",")
   sx,sy = sx[1:],sy[:-1]
   sx,sy = sx.split(":"),sy.split(":")
   sx = map(int,sx)
   sy = map(int,sy)
   if sx[0] > sx[1]: data = data[::,::-1]; sx = sx[1],sx[0]
   if sy[0] > sy[1]: data = data[::-1]; sy = sy[1],sy[0]

   detsec = "[%d:%d,%d:%d]" % (sy[0],sy[1],sx[0],sx[1])
   data = transpose(data)

   naxes = list(data.shape)
   naxes.reverse()

   template = "%s[%d]" % (input,fno+1)
   noutput = "%s_%d.fits" % (output,fno+1)
   print "Writing %s using %s as template." % (noutput, template)
   F=FITS(noutput,create=1,template=template)
   F.inskey("xtension","simple",True)
   F.delkey("xtension")
   F.modkey("bitpix",outbitpix)
   F.delkey("bscale")
   F.delkey("bzero")
   F.modkey("transposed",True)
   F.modkey("detsec",detsec)
   F.modkey("exptime",exptime)
   F.resize(naxes)
   F.putdata( data)
   F.close()

