
from basics import *

def L2(x,w=0):
    if w:
       return ones(x.shape,x.typecode())
    else:
       return 0.5*power(x,2)

def L1(x,w=0):
    if w:
       return divz(1,abs(x))
    else:
       return abs(x)

def L1L2(x,w=0):
    if w:
       return 1/sqrt(1+x**2/2)
    else:
       return 2*(sqrt(1+x**2/2)-1)

def Lp(x,p=1.2,w=0):
    if w:
       b = equal(x,0)
       return power(b+abs(x),p-2)*(1-b)
    else:
       return power(abs(x),p)/p

def Fair(x,c=1.3998,w=0):
    if w:
       return 1/(1+abs(x)/c)
    else:
       return c**2*(abs(x)/c - log(1+abs(x)/c))

def Cauchy(x,c=2.3849,w=0):
    if w:
       return 1/(1+(x/c)**2)
    else:
       return (c**2/2)*log(1+(x/c)**2)

def Huber(x,c=1.345,w=0):
    h0 = less(abs(x),c)
    if w:
       h1 = ones(x.shape,x.typecode())
       h2 = divz(c,abs(x))
    else:
       h1 = 0.5*power(x,2)
       h2 = c*(abs(x)-c/2.)
    return where(h0,h1,h2)

def Huber2(x,c=1.2107,w=0):
    h0 = less(abs(x),c*pi/2.)
    if w:
       h1 = divz(sin(x/c),x/c,repl=1)
       h2 = divz(c,abs(x))
    else:
       h1 = c**2*(1-cos(x/c))
       h2 = c*abs(x) + c**2*(1-pi/2)
    return where(h0,h1,h2)

def Welsch(x,c=2,w=0):
    if w:
       return exp(-(x/c)**2)
    else:
       return (c**2/2)*(1-exp(-(x/c)**2))

def Tukey(x,c=4.6851,w=0):
    h0 = less(abs(x),c)
    if w:
       h1 = (1-power(x/c,2))**2
       h2 = zeros(x.shape,Float)
    else:
       h1 = c**2/6. * (1-(1-power(x/c,2))**3)
       h2 = c**2/6.
    return where(h0,h1,h2)

