
from basics import *

def OrthoFit(sol,x,y,c,wt=0,verb=0):
    n = len(x)
    svds = [singular_value_decomposition(a) for a in c]
    wts = asarray([svd[1] for svd in svds])
    wts = where(abs(wts) < 1e-10, 0.0, wts)
    vecs = asarray([svd[2] for svd in svds])
#    vecs = asarray([array([[1,0],[0,1]]) for svd in svds])
    errs = sqrt(wts)[::,::,NewAxis]*vecs
    s = array([1.0,-1.0/sol[1]])/sqrt(1+1.0/sol[1]**2)
    r = (sol[0] + sol[1]*x) - y
    if wt:
      d1 = array([dot(r[j]*s,divz(1,errs[j,0])) for j in range(n)])
      d2 = array([dot(r[j]*s,divz(1,errs[j,1])) for j in range(n)])
      d = concatenate([d1,d2])
    else:
      d1 = array([dot(r[j]*s,vecs[j,0]) for j in range(n)])
      d2 = array([dot(r[j]*s,vecs[j,1]) for j in range(n)])
      d = concatenate([d1,d2])
    d = array(d)
#    mz = median(d)
#    mr = median(abs(d-mz))
#    d = [abs(mz),mr]
#    print sol,rms(d)
    if verb: print sol,rms(d)
    return d


