#!/usr/bin/env python

from FITS import FITS
from glob import glob
from basics import *

def getReferences(ims):
    fs = [FITS(im) for im in ims]
    fsx = [f.naxes()[0] for f in fs]
    fsy = [f.naxes()[1] for f in fs]
    [f.close() for f in fs]
    gls = glob("comblist*")
    glp = [split(g,"_") for g in gls]
    roots = [i[:-5] for i in ims]
    pieces = [split(r,"_") for r in roots]
    cbs = [["comblist"]+p for p in pieces]
    [g.sort() for g in glp]
    [c.sort() for c in cbs]
    icl = [glp.index(c) for c in cbs]
    cls = [gls[i] for i in icl]
    print "Reading"
    print cls
    tbls = [readtable(c,tcols=[0]) for c in cls]
    offx = [2*t[3] for t in tbls]
    offy = [2*t[4] for t in tbls]
    minxs = [min(o) for o in offx]
    minys = [min(o) for o in offy]
    xshifts = [(offx[o]-minxs[o]+0.5).astype(Int32) for o in range(len(tbls))]
    yshifts = [(offy[o]-minys[o]+0.5).astype(Int32) for o in range(len(tbls))]
    n = [i for i in t[0] for t in tbls]
    a = [(i in tbls[0][0] and i in tbls[1][0] and i in tbls[2][0] and i in tbls[3][0]) for i in t[0] for t in tbls]
    u = n[nonzero(a)[0]]
    nr = [t[0].index(u) for t in tbls]
#    nxs = [argmax(xshifts[j]) for j in range(len(tbls))]
#    nys = [argmax(yshifts[j]) for j in range(len(tbls))]
    filer = [tbls[j][0][nr[j]] for j in range(len(tbls))]
    print filer
    rx = [1024+xshifts[j][nr[j]] for j in range(len(tbls))]
    ry = [1024+yshifts[j][nr[j]] for j in range(len(tbls))]
    print rx,ry
    return rx,ry

