#!/usr/bin/env python

#from twisted.internet import selectreactor
#selectreactor.install()

from twisted.internet import defer, protocol, reactor, address
from twisted.internet import interfaces, process
from twisted.internet import abstract, threads, task
from twisted.conch.ssh import transport, userauth, connection, common, keys, channel, forwarding, session
from twisted.conch.client import direct
from twisted.conch.insults import insults
from twisted.conch.manhole import Manhole
from twisted.conch.manhole_ssh import ConchFactory, TerminalRealm
from twisted.conch.stdio import ConsoleManhole
from twisted.conch.telnet import TelnetTransport, TelnetBootstrapProtocol
from twisted.application import service
from twisted.python import util, threadable
from twisted.python import log, usage
from twisted.spread import pb, jelly, flavors, banana
from twisted.cred.portal import IRealm, Portal
from twisted.cred.checkers import InMemoryUsernamePasswordDatabaseDontUse, AllowAnonymousAccess
from twisted.cred.credentials import UsernamePassword, Anonymous
from twisted.cred.credentials import IUsernamePassword, IAnonymous
from zope.interface import implements

from types import *
from sys import argv
import getpass, time, copy
import struct, sys, getpass, os, time, random, string
import posix, socket, sets
import cStringIO, cPickle, traceback
import imp
import curses, curses.wrapper

from Numeric import argsort, ArrayType

PickleTypes = [ArrayType]

DEFAULTPORT = 8789
orig_path = copy.copy(sys.path)

#if sys.argv[0].split("/")[-1] not in ["TwistedServer"]:
#   USER = getpass.getuser()
#   PASSWORD = getpass.getpass("%s's password: " % (USER))

HOST = os.uname()[1]
IMPORTS = {}

if os.path.exists(".Twisted"):
   o = open(".Twisted","r")
   MACHINES = [str(l[:-1].strip()) for l in o.readlines() if l[0] != "#"]
   o.close()
elif os.environ.has_key('TWISTEDSERVERS'):
   MACHINES = os.environ['TWISTEDSERVERS'].split(",")
else:
   MACHINES = []

def twisted_import(name,comps=None):
   global IMPORTS
   fo,pn,desc = imp.find_module(name)
   mstat = os.stat(pn)
   if pn not in IMPORTS or mstat != IMPORTS[pn][1]:
      mload = True
      modobj = imp.load_module(name,fo,pn,desc)
   else:
      mload = False
      modobj = IMPORTS[pn][0]
   fo.close()
   IMPORTS[pn] = (modobj,mstat)
   if comps == "*":
     s = "from %s import *" % (name)
     if mload: print s
     for k in dir(modobj):
       globals()[k] = getattr(modobj,k)
   elif comps:
     s = "from %s import %s" % (name,comps)
     if mload: print s
     for k in comps.split(","):
       globals()[k] = getattr(modobj,k)
   else:
     s = "import %s" % (name)
     if mload: print s
     globals()[name] = modobj
   sys.stdout.flush()
   return s


def rdarg(argv,key,conv=None,default=None,single=0):
   val = default
   if key in argv:
    if not single:
      val=argv[argv.index(key)+1]
      del argv[argv.index(key):argv.index(key)+2]
      if conv: val=map(conv,[val])[0]
    else:
      del argv[argv.index(key):argv.index(key)+1]
      val = 1
      if default == 1: val=0
   else:
      if conv and val: val=apply(conv,(val,))
   return argv,val

class SimpleTransport(transport.SSHClientTransport):
    def __init__(self,hub=None,user="",password="",lport=0,verb=0,clean=0):
        self.hub = hub
        self.user = user
        self.password = password
        self.verb = verb
        self.clean = clean
        c = string.letters+string.digits
        self.user2 = "".join([random.choice(c) for k in range(random.randint(10,20))])
        self.password2 = "".join([random.choice(c) for k in range(random.randint(10,20))])
        self.lport = lport
    def verifyHostKey(self, hostKey, fingerprint):
        if self.verb: print 'host key fingerprint: %s' % fingerprint
        return defer.succeed(1) 
    def connectionSecure(self):
        sc = SimpleConnection()
        sc.hub = self.hub
        sc.lport = self.lport
        sc.transport = self
        sc.user2 = self.user2
        sc.password2 = self.password2
        sc.verb = self.verb
        sc.clean = self.clean
        sua = SimpleUserAuth(self.user,sc)
        sua.password = self.password
        sua.verb = self.verb
        self.requestService(sua)

class SimpleClientFactory(protocol.ClientFactory):
    def __init__(self,hub=None,user="",password="",lport=0,verb=0,clean=0):
        self.hub = hub
        self.user = user
        self.password = password
        self.lport = lport
        self.verb = verb
        self.clean = clean
    def buildProtocol(self,addr):
        p = self.protocol(hub=self.hub,user=self.user,password=self.password,lport=self.lport,verb=self.verb,clean=self.clean)
        p.factory = self
        return p

class SimpleUserAuth(userauth.SSHUserAuthClient):
    def getPassword(self):
        return defer.succeed(self.password)
    def getGenericAnswers(self, name, instruction, questions):
        if self.verb:
           print name
           print instruction
        answers = []
        for prompt, echo in questions:
            if echo: 
                answer = raw_input(prompt)
            else:
                answer = getpass.getpass(prompt)
            answers.append(answer)
        return defer.succeed(answers)
    def getPublicKey(self):
        path = os.path.expanduser('~/.ssh/id_dsa') 
        # this works with rsa too
        # just change the name here and in getPrivateKey
        if not os.path.exists(path) or hasattr(self, 'lastPublicKey'):
            # the file doesn't exist, or we've tried a public key
            return
        return keys.getPublicKeyString(path+'.pub')
    def getPrivateKey(self):
        path = os.path.expanduser('~/.ssh/id_dsa')
        return defer.succeed(keys.getPrivateKeyObject(path))

class SimpleConnection(connection.SSHConnection):
    def serviceStarted(self):
        self.localForwards = []
        self.ch1 = InitChannel()
        self.last = None
        self.openChannel(self.ch1)
    def serviceStopped(self):
        lf = self.localForwards
        self.localForwards = []
        for s in lf: s.loseConnection()

class SSHListenClientForwardingChannel(forwarding.SSHListenClientForwardingChannel): pass

class InitChannel(channel.SSHChannel):
    name = "session"
    def openFailed(self, reason):
        sys.stdout.write("echo failed: %s\n" % (reason))

    def channelOpen(self, ignoredData):
        self.rport = 0
        self.rhost = "None"
        self.log = ""
        command = self.conn.hub.COMMAND
        sys.stdout.write(command+"\n")
        d = self.conn.sendRequest(self, 'exec', common.NS(command), wantReply = 0)
        self.conn.hub.STARTED.append(self.conn)
#        d.addCallback(self._cbRequest)
#
#    def _cbRequest(self,ignored):
#         self.conn.hub.STARTED.apppend(self.conn)

    def closeReceived(self):
        if self.conn in self.conn.hub.RUNNING:
            self.conn.hub.RUNNING.remove(self.conn)
            if self.conn in self.conn.hub.CONNECTORS:
                self.conn.hub.CONNECTORS.pop(self.conn)
                if not self.conn.hub.finish and not self.conn.hub.die:
                   reactor.callInThread(self.conn.hub.AddHost,self.rhost)

    def dataReceived(self, data):
        self.log = self.log + data
        if self.conn.verb:
           sys.stdout.write('Data from %s(%d):\n' % (self.rhost,self.rport))
           sys.stdout.write( data)
           sys.stdout.flush()
        self.conn.hub.out.write('Data from %s(%d):\n' % (self.rhost,self.rport))
        self.conn.hub.out.write( data)
        self.conn.hub.out.flush()
        data = data.split("\n")
        for line in data:
           if "No longer running the reactor!" in line:
              self.loseConnection()
#              if self.conn in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self.conn)
           elif "THIS MACHINE IS" in line:
              line = line.strip().split()
              self.rhost = line[3][:-1]
              self.rhostop = line[5][:-1]
           elif "ENTER USERNAME" in line:
              self.write(self.conn.user2+"\n")
           elif "ENTER PASSWORD" in line:
              self.write(self.conn.password2+"\n")
           elif "SSH PORT" in line:
              line = line.strip().split("=")
              self.sport = int(line[1])
           elif "USING PORT" in line:
              line = line.strip().split("=")
              if len(line) == 2:
                 if not (self.conn.hub.finish or self.conn.hub.die):
                    self.rport = int(line[1])
                    s = reactor.listenTCP(0,
                           forwarding.SSHListenForwardingFactory(self.conn,
                                   (self.rhost,self.rport),
                                   SSHListenClientForwardingChannel))
                    self.lport = s.getHost().port
                    if 1 or self.conn.verb:
                       text = "Forwarding local port %d to remote port %d\n" % (self.lport,self.rport)
                       sys.stdout.write( text)
                    reactor.callFromThread(reactor.wakeUp)
                    s.startReading()
                    self.conn.localForwards.append(s)
                    self.conn.hub.MakeConnector(self.conn)

    def extReceived(self, dataType, data):
        self.log = self.log + data
        text = 'extData from %s(%d):\n' % (self.rhost,self.rport)
        sys.stdout.write( text)
        sys.stdout.write( data)
        sys.stdout.flush()
        self.conn.hub.err.write( text)
        self.conn.hub.err.write( data)
        self.conn.hub.err.flush()

    def closed(self):
        self.loseConnection()
#        if self.conn in self.conn.hub.RUNNING: self.conn.hub.RUNNING.remove(self.conn)

cwd = os.getcwd()
scwd = cwd.split("/")
op,host = os.uname()[:2]
if op == "Darwin":
   if scwd[1] == "Users":
      scwd[1] = "home/%s" % (host.split(".")[0])
      cwd = "/".join(scwd)
   elif scwd[1] == "Volumes":
      scwd[1:3] = [scwd[2],host.split(".")[0]]
      cwd = "/".join(scwd)

class TwistedTask(flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","modules","fmodules","path","env","done","ohost","port"
       self.taskid = taskid
       self.ohost = None
       self.port = -1
       self.func = func
       if "path" in kws:
          self.path = kws["path"]
          kws.pop("path")
       else:
          self.path = os.getcwd()
       if "host" in kws:
          self.host = kws["host"]
          kws.pop("host")
       if "cleanup" in kws:
          self.cleanup = kws["cleanup"]
          kws.pop("cleanup")
       if "condition" in kws:
          self.setCondition(kws["condition"])
          kws.pop("condition")
       self.args = cPickle.dumps(args)
       self.kws = cPickle.dumps(kws)
       self.modules = []
       self.fmodules = []
       self.env = cPickle.dumps(os.environ)
       self.done = False
       self.imported = False
   def __repr__(self):
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,self.func,self.done)
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
   def setResult(self,result):
       self.result = result
       self.done = True
   def setCondition(self,condition):
       self.condition = condition
   def getCondition(self):
       return self.condition()

class CopyTask(flavors.Copyable):
   def __init__(self,taskid=0,func=None,*args,**kws):
       self.elements = "taskid","func","args","kws","modules","fmodules","path","env","done","ohost","port"
       self.taskid = taskid
       self.ohost = None
       self.port = -1
       self.func = func
       self.args = cPickle.dumps(args)
       self.kws = cPickle.dumps(kws)
       self.modules = []
       self.fmodules = []
       self.path = os.getcwd()
       self.env = cPickle.dumps(os.environ)
       self.done = False
       self.imported = False
   def __repr__(self):
       return "TwistedTask %r (%s:%d): %s / Done: %r" % (self.taskid,self.ohost,self.port,self.func,self.done)
   def setPath(self,path):
       self.path = path
   def setEnv(self,env):
       self.env = cPickle.dumps(env)
   def setModules(self,modules):
       self.modules = modules
   def setFromModules(self,fmodules):
       self.fmodules = fmodules
   def setResult(self,result):
       self.result = result
       self.done = True

class ReceiverTask(flavors.RemoteCopy,TwistedTask):
     pass
pb.setUnjellyableForClass(CopyTask, ReceiverTask)

def TestTask(task):
    os.chdir(task.path)
    return eval(task.func)(*cPickle.loads(task.args),**cPickle.loads(task.kws))

class HubRealm:
    implements(IRealm)
    def setHub(self,hub):
        self.hub = hub
        self.spawn = HubSpawn()
        self.spawn.setHub(self.hub)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.spawn, lambda : None
        else:
            raise NotImplementedError("no interface")

class HubSpawn(pb.Avatar):
   from TwistedHub import TwistedTask, CopyTask
   def setHub(self,hub):
       self.hub = hub
       print "Adopting hub:",hub
   def perspective_info(self):
       info = {}
       info["numrunners"] = len(self.hub.RUNNING)
       return info
   def perspective_task(self,otask):
       print "Received:",otask
       if "reactor.stop" in otask.func:
           self.hub.finish = 1
       else:
           otask.imported = True
           reactor.callFromThread( self.hub.tasks.append,otask)
       return True

class TwistedHub:
   from TwistedHub import TwistedTask, CopyTask
   def __init__(self,tasks=[],timeout=30,port=0,quiet=0,verb=0,sleeptime=0.1,clean=0,norun=0,wait=0,\
        listen=-1,stayalive=0,user=getpass.getuser(), uid=getpass.getuser(), password=None,gdir=None,\
        machines=MACHINES,modules=[],fmodules=[],namespace=globals(),sshport=0,nostop=0,nice=10,auth=0,\
        standalone=1):
       self.initialize()
       self.standalone = standalone
       if namespace:
          self.namespace=namespace
          self.namespace["self"] = self
       else: self.namespace = locals()
       self.dispatchers = {}
       self.gdir = gdir
       self.user = user
       self.auth = auth
       if password: self.password = password
       elif "pw" in os.environ: self.password = os.environ["pw"]
       elif "pwfile" in os.environ and os.path.exists(os.environ["pwfile"]): self.password = open(os.environ["pwfile"],"r").read().strip()
       else: self.password=getpass.getpass("%s's password: " % (self.user))
       self.sshport = sshport
       self.machines = machines
       self.modules = modules
       self.fmodules = fmodules
       self.nostop = nostop
       self.tasks = tasks
       self.completed = []
       self.adding = []
       self.sending = []
       self.nsend = 0
       self.lport = port
       self.verb = verb
       self.uid = uid
       self.clean = clean
       self.norun = norun
       self.finish = 0
       self.listen = listen
       self.stayalive = stayalive
       COMMAND = "TwistedStation"
       self.COMMAND = " ".join([COMMAND,"-uid",self.uid])
       self.nicelevel = nice
       if self.nicelevel != None:
          self.COMMAND = " ".join([self.COMMAND,"-nice %d" % (self.nicelevel)])
       if self.gdir:
          self.COMMAND = " ".join([self.COMMAND,"-dir",self.gdir])
       if self.clean:
          self.COMMAND = " ".join([self.COMMAND,"-clean"])
       if self.norun:
          self.COMMAND = " ".join([self.COMMAND,"-norun"])
       if self.modules:
          self.COMMAND = " ".join([self.COMMAND,"-i",",".join(self.modules)])
       if self.fmodules:
          self.COMMAND = " ".join([self.COMMAND,"-f",",".join(self.fmodules)])
       self.wait = wait
       self.sleeptime = sleeptime
       self.ntasks = len(tasks)
       self.timeout = timeout
       self.began = False
       self.done = False
       self.die = False
       pstart = time.time()
       pend = time.time()
       if (pend-pstart) > 180: raise "Time to enter password exceeded!"
       self.pid = os.getpid()
       self.out = open("/tmp/hub%d.out" % (self.pid),"w")
       self.err = open("/tmp/hub%d.err" % (self.pid),"w")
       if quiet:
          sys.stdout = self.out
          sys.stderr = self.err
       self.tstart = time.time()
       self.clientFactory = SimpleClientFactory(hub=self,user=self.user,password=self.password,lport=self.lport,verb=self.verb,clean=self.clean)
       self.clientFactory.protocol = SimpleTransport
       self.log = cStringIO.StringIO()
       if 1 or self.verb:
          log.startLogging(self.log,setStdout=0)
#       reactor.suggestThreadPoolSize(len(self.machines)+5)
       p = AddManhole(self.user,self.password,self.namespace,self.sshport)
       self.out.write("ssh port = %d\n" % (p))
       self.out.flush()
       self.passback = []
       [reactor.callInThread(self.AddHost,host) for host in self.machines]
       if self.listen >= 0:
          reactor.callInThread(self.Listening)
       if self.wait:
          reactor.callInThread(self.WatchAdded)
       else:
          reactor.callInThread(self.WatchRunning)
       if self.standalone:
          reactor.run()
          if quiet:
             sys.stdout = sys.__stdout__
             sys.stderr = sys.__stderr__
          self.out.close()
          self.err.close()
          if not quiet:
             os.remove(self.out.name)
             os.remove(self.err.name)
   def initialize(self):
       self.TASKS = {}
       self.RESULTS = {}
       self.RUNNING = []
       self.STARTED = []
       self.CONNECTORS = {}
       self.LC = {}
       self.SSH = {}
       self.KILL = {}
   def AddHost(self,host):
       self.SSH[host] = reactor.connectTCP(host,22,self.clientFactory,timeout=self.timeout)
       reactor.wakeUp()
       text = "Added %s (%s)\n" % (host,self.SSH[host].state)
       sys.stdout.write( text)
   def WatchAdded(self):
       if self.norun:
          while len(self.STARTED) < len(self.machines): time.sleep(0.1)
       else:
          nr = len(self.CONNECTORS.keys())
          while len(self.CONNECTORS.keys()) < len(self.machines):
             if nr != len(self.CONNECTORS.keys()):
                hosts = [h.ch1.rhost for h in self.CONNECTORS]
                text = "(%d/%d) %r\n" %  (len(self.CONNECTORS.keys()),len(self.machines),hosts)
                sys.stdout.write( text)
                nr = len(self.CONNECTORS.keys())
             time.sleep(self.sleeptime)
          text =  "\nAll %d cylinders firing away!\n" % (len(self.CONNECTORS.keys()))
          sys.stdout.write( text)
       self.began = True
       reactor.callInThread(self.WatchRunning)
   def MakeConnector(self,host):
       if not (self.finish or self.die):
          rhost = host.ch1.rhost
          rport = host.ch1.rport
          sport = host.ch1.sport
          lport = host.ch1.lport
          user = host.user2
          password = host.password2
          text = "Creating connector to local port %d.\n" % (lport)
          sys.stdout.write( text)
          text = "Creating connector to %s:%d (%s,%s,%d) using local port %d.\n" % (rhost,rport,user,password,sport,lport)
          self.out.write( text)
          self.out.flush()
          text = "ssh %s@%s -p %d\n" % (user,rhost,sport)
          self.out.write( text)
          self.out.flush()
          factory = pb.PBClientFactory()
          connector = reactor.connectTCP('localhost',lport,factory)
          FireItUp = self.FireItUp
          d = factory.login(UsernamePassword(user,password))
          d.addCallback(lambda remote: FireItUp(host,connector,remote))
          reactor.callFromThread(reactor.wakeUp)
   def FireItUp(self,host,connector,remote):
       self.TASKS.setdefault(host,[])
       self.RESULTS.setdefault(host,[])
       self.CONNECTORS.setdefault(host,[connector,remote])
       self.RUNNING.append(host)
#       reactor.callInThread(self.SpawnToHost,host)
#       reactor.callInThread(reactor.wakeUp)
   def WatchSpawn(self):
       if self.tasks or self.adding:
          self.adding.extend([otask for otask in self.tasks if not hasattr(otask,"condition") or otask.getCondition()])
          [self.tasks.remove(otask) for otask in self.adding if otask in self.tasks]
#          left = [host for host in self.RUNNING if not hasattr(host,"timing")]
#          order = argsort([host.timing for host in self.RUNNING if hasattr(host,"timing")])
#          running = [self.RUNNING[j] for j in order] + left
          running = self.RUNNING
          for host in running:
#             if self.TASKS[host] == [] and (not host.last or host.last.done and \
#                  (not host.last.imported or hasattr(host.last,"sent"))):
             if self.TASKS[host] == []:
               sname = host.ch1.rhost.split(".")[0]
               atask = None
               for otask in self.adding:
                  if not hasattr(otask,"assigned") and (not hasattr(otask,"host") \
                      or (otask.host == sname)):
                      otask.assigned = True
                      if 1 or self.verb: print "ASSIGNING %r to %s" % (otask.taskid,sname)
                      atask = otask
                      self.TASKS[host].append(otask)
                      reactor.callInThread(self.SpawnToHost,host)
                      break
               if atask: self.adding.remove(atask)
               reactor.callFromThread(reactor.wakeUp)
   def WatchRunning(self):
       self.tnow = time.time()
       text = "Starting up!\n"
       reactor.callFromThread(reactor.wakeUp)
       sys.stdout.write( text)
       if self.norun:
          while len(self.STARTED) < len(self.machines): time.sleep(0.1)
       else:
          while not len(self.CONNECTORS.keys()): time.sleep(self.sleeptime)
          print "Running!"
          ws = task.LoopingCall(self.WatchSpawn)
          ws.start(self.sleeptime)
          l = 0
          nr0 = 0
          while not self.finish and not self.die:
             l = l + 1
             time.sleep(self.sleeptime)
             nr = len(self.completed)
             if not self.stayalive and nr == self.ntasks: self.finish = 1
             if (self.verb and not (l%40)) or (nr != nr0):
                sys.stdout.write("%d %d %d\n" % (nr,self.ntasks,self.finish))
                sys.stdout.flush()
             nr0 = nr
          reactor.callFromThread(self.Gather)
          if self.die:
             text =  "\nDying prematurely with %d tasks!\n" % (len(self.tasks)+len(self.adding))
          else:
             text =  "\nAll done!\n"
          ws.stop()
          sys.stdout.write( text)
          sys.stdout.flush()
          reactor.callFromThread(reactor.wakeUp)
          while len(self.CONNECTORS.keys()) < len(self.machines):
             text =  "Waiting for remaining %d stations to start up so we can kill them, too...\n" % \
                (len(self.machines)-len(self.CONNECTORS.keys()))
             sys.stdout.write( text)
             sys.stdout.flush()
             reactor.callFromThread(reactor.wakeUp)
             time.sleep(self.sleeptime)
          self.End()
          text =  "Waiting for things to shut down...\n"
          sys.stdout.write( text)
          sys.stdout.flush()
          while self.RUNNING: time.sleep(sleeptime)
       text = "Can we call reactor.stop yet?\n"
       sys.stdout.write( text)
       text = "Now we can!\n"
       sys.stdout.write( text)
       self.done = True
       self.tend = time.time()
       text = "Time to execute=%f\n" % (self.tend-self.tstart)
       sys.stdout.write( text)
       if not self.nostop: self.Stop()
   def Gather(self):
       results = [result for host in self.RESULTS for result in self.RESULTS[host] if hasattr(result,"done")]
       order = argsort([result[2] for result in results])
       results = [results[j] for j in order]
       self.timings = [result[0] for result in results]
       self.loads = [result[1] for result in results]
       self.indices = [result[2] for result in results]
       self.results = [result[3] for result in results]
   def Elapsed(self):
       return time.time()-self.tstart
   def rhosts(self):
       return [h.ch1.rhost for h in self.RUNNING]
   def Stop(self):
       if not self.norun:
          [host.ch1.loseConnection() for host in self.RESULTS]
          [host.serviceStopped() for host in self.RESULTS]
       if self.standalone:
          reactor.callFromThread(reactor.disconnectAll)
          reactor.callFromThread(reactor.stop)
   def End(self):
       sys.stdout.flush()
       self.die = 1
       while self.RUNNING:
          time.sleep(self.sleeptime)
          for host in self.RUNNING:
              if host in self.TASKS and self.TASKS[host] == []:
                  self.TASKS[host].append(TwistedTask(-1,"reactor.stop"))
                  reactor.callInThread(self.SpawnToHost,host)
   def SpawnToHost(self,host):
       if host in self.TASKS:
           time.sleep(self.sleeptime)
           if host not in self.RUNNING:
               self.TASKS.pop(host)
               return 
#               break
           if self.TASKS[host]:
                otask = self.TASKS[host][0]
                ctask = CopyTask()
                for attr in otask.elements:
                   setattr(ctask,attr,getattr(otask,attr))
                cwd = otask.path
                scwd = cwd.split("/")
                op,lhost = os.uname()[:2]
                if lhost != host.ch1.rhost and op != host.ch1.rhostop:
                   if op == "Darwin":
                      if scwd[1] == "Users":
                         scwd[1] = "home/%s" % (lhost.split(".")[0])
                         cwd = "/".join(scwd)
                      elif scwd[1] == "Volumes":
                         scwd[1:3] = [scwd[2],lhost.split(".")[0]]
                         cwd = "/".join(scwd)
                ctask.setPath(cwd)
                if "reactor.stop" not in ctask.func: ctask.setEnv(os.environ)
                if self.verb:
                   text = "sending %r to %s(%d<-%d)\n" % (ctask.taskid,host.ch1.rhost,host.ch1.rport,host.ch1.lport)
                   sys.stdout.write( text)
                while host not in self.CONNECTORS:
                   if verb:
                      print "Waiting for connector?"
                      sys.stdout.flush()
                   time.sleep(self.sleeptime)
                connector,remote = self.CONNECTORS[host]
                if connector.state == "disconnected":
                    if self.verb: print "Need to reconnect?!?!??"
                    connector.connect()
                while connector.state != "connected":
                     if self.verb: print "Waiting for connection!"
                     time.sleep(self.sleeptime)
                tstart = time.time()
                d = remote.callRemote("task",ctask)
                host.last = d
                host.last.done = False
                if "reactor.stop" not in ctask.func:
                   d.addCallback(lambda result: [time.time()-tstart]+list(result))
                   d.addErrback(lambda reason: (reason.value))
                   if host in self.RESULTS:
                      reactor.callFromThread(self.RESULTS[host].append,d)
                   else: 
                      reactor.callFromThread(self.RESULTS.setdefault,host,[d])
                reactor.callFromThread(reactor.wakeUp)
                if self.verb: print "Waiting for result",otask.taskid
                if "reactor.stop" in otask.func:
                    self.TASKS[host].pop(otask)
                    self.TASKS.pop(host)
                else:
                    while not (d.called and not d.paused) or \
                        not hasattr(d,"result") or type(d.result) == TupleType:
                        time.sleep(self.sleeptime)
                    if self.verb: print "Got result for",otask.taskid
                    if hasattr(d,"result"):
                       results = d.result
                       if results[4]: results[3] = cPickle.loads(results[3])
#                       host.timing = results[0]
#                       host.load = results[1][0]
                       otask.setResult(results)
                       print otask
                       print results[:3]
                       self.completed.append(otask)
                       if self.verb:
                          sys.stdout.write("%s\n" % (str(d.result)))
                          sys.stdout.write("Time to execute for %r was %f.\n" % (otask.taskid,d.result[0]))
                       sys.stdout.flush()
                       if otask.imported:
                           if self.verb: print "Sending back",otask.taskid
                           reactor.callInThread( self.QueueBack,otask)
                    elif self.RUNNING:
                       sys.stdout.write("Reinserting the task into the queue!\n")
                       sys.stdout.flush()
                       delattr(otask,"assigned")
                       self.tasks.insert(0,otask)
                    else:
                       sys.stdout.write("Ran out of connected stations!\n")
                       sys.stdout.flush()
                       reactor.callFromThread(self.End)
                       reactor.callFromThread(self.Stop)
#                    if otask.imported:
#                       while not hasattr(otask,"sent"):
#                         if self.verb: print "Waiting for send back!"
#                         time.sleep(self.sleeptime)
                    self.TASKS[host].remove(otask)
                    host.last.done = True
   def Listening(self):
       self.realm = HubRealm()
       self.realm.setHub(self)
       self.portal = Portal(self.realm)
       if self.auth:
          print "Access set to",self.user
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser(self.user,self.password)
       else:
          print "Access set to anonymous"
          checker = InMemoryUsernamePasswordDatabaseDontUse()
          checker.addUser("anonymous","anonymous")
       self.portal.registerChecker(checker)
       self.listen = reactor.listenTCP(self.listen, pb.PBServerFactory( self.portal))
       port = self.listen.getHost().port
       sys.stdout.write("HUB PORT=%d\n" % (port))
       sys.stdout.flush()
       self.out.write("HUB PORT=%d\n" % (port))
       self.out.flush()
   def NewDispatcher(self,otask=None):
       dispatcher = (otask.ohost,otask.port)
       print "Making new connection back to dispatcher",dispatcher,otask.taskid
       self.dispatchers[dispatcher] = False
       factory = pb.PBClientFactory()
       connector = reactor.connectTCP(otask.ohost,otask.port,factory)
       if self.auth:
          d = factory.login(UsernamePassword(self.user,self.password))
       else:
          d = factory.login(UsernamePassword("anonymous","anonymous"))
       reactor.callFromThread(reactor.wakeUp)
       b = time.time()
       while not hasattr(d,"result") or connector.state != "connected" or \
               not isinstance(d.result,pb.RemoteReference):
          if self.verb: print "Waiting for connection back to",dispatcher
          time.sleep(self.sleeptime)
          t = time.time()-b
          if t > 5:
             print "Timeout on connection!"
             connector.disconnect()
             return False
       self.dispatchers[dispatcher] = d.result,connector
       print otask.taskid,connector.state
       return True
   def QueueBack(self,otask=None):
       if not hasattr(self,"queueback"):
            self.queueback = []
            reactor.callInThread(self.SendBack)
       reactor.callFromThread(self.queueback.append,otask)
   def SendBack(self):
       while self.stayalive and not self.finish and not self.die:
          time.sleep(self.sleeptime)
          if self.queueback:
              otask = self.queueback.pop(0)
              dispatcher = (otask.ohost,otask.port)
              if dispatcher not in self.dispatchers:
                 dt = self.NewDispatcher(otask)
                 while not dt:
                    time.sleep(1.0)
                    print "Try again for",otask.taskid
                    dt = self.NewDispatcher(otask)
              else:
                  while dispatcher not in self.dispatchers or \
                       not self.dispatchers[dispatcher]:
                     print "Wait for dispatcher!"
                     time.sleep(1.0)
              remote,connector = self.dispatchers[dispatcher]
              if self.verb: print "Sending back:",otask.taskid,otask
              if self.verb: print "Over port:",otask.port
              if self.verb: print dispatcher, connector.state
              while connector.state != "connected":
                 print "Waiting to connect!"
                 time.sleep(1.0)
              result = otask.result
              presult,p = cPickle.dumps(result),1
              s = remote.callRemote("result",otask.taskid,presult,p)
              while not hasattr(s,"result"):
                time.sleep(self.sleeptime)
                if self.verb: print "Waiting for verification for",otask.taskid
              if hasattr(s,"result"):
                 print "Sent back",s.result
                 otask.sent = True

class HubAvatar(pb.Avatar):
    def __init__(self,hub):
        self.hub = hub
    def perspective_func(self,otask):
        task = TwistedTask()
        for attr in otask.elements:
           if getattr(otask,attr):
             setattr(task,attr,getattr(otask,attr))
        if self.hub.verb: print "Got:",task
        self.hub.addTask(task)
        while not hasattr(task,"result") or not hasattr(task.result,"result") or \
               not isinstance(task.result,pb.RemoteReference):
            if self.hub.verb: print hasattr(task,"result")
            time.sleep( self.hub.sleeptime)
            if self.hub.verb: print "Waiting for results for",task
        if self.hub.verb: print hasattr(task,"result")
        return task.result

class TaskRealm:
    implements(IRealm)
    def __init__(self,dispatcher):
        self.dispatcher = dispatcher
        self.receive = TaskResult()
        self.receive.dispatcher = self.dispatcher
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.receive, lambda : None
        else:
            raise NotImplementedError("no interface")

class TaskResult(pb.Avatar):
   def perspective_result(self,taskid,result,p):
       print "Got result for task",taskid
       if p: result = cPickle.loads(result)
       sys.stdout.flush()
       mtasks = [otask for otask in self.dispatcher.queued if otask.taskid == taskid]
       if mtasks:
          otask = mtasks[0]
          otask.setResult(result)
          return otask.taskid
       else:
          return -1

class HubDispatch:
   def __init__(self,tasks,hub,user=None,password=None,namespace=None,sleeptime=0.1,verb=0,mport=0,restart=0):
       self.tasks = tasks
       self.verb = verb
       self.completed = []
       self.hub = hub
       self.user = user
       self.password = password
       if not self.password and self.user:
          self.password = getpass.getpass("%s's password:" % (self.user))
       self.sleeptime = sleeptime
       self.mport = mport
       if namespace:
          self.namespace=namespace
          self.namespace["self"] = self
       else: self.namespace = locals()
       reactor.callInThread(self.Manhole)
       reactor.callInThread(self.Start)
       if not reactor.running:
           reactor.run()
   def Manhole(self):
       if self.user:
          user,password = self.user,self.password
       else:
          user,password = "anonymous","anonymous"
       AddManhole(user,password,namespace=self.namespace,port=self.mport)
   def Connect(self):
       factory = pb.PBClientFactory()
       self.connector = reactor.connectTCP(self.hub[0],self.hub[1],factory)
       if self.user:
          c = UsernamePassword(self.user,self.password)
       else:
          c = UsernamePassword("anonymous","anonymous")
       d = factory.login(c)
       reactor.callFromThread(reactor.wakeUp)
       while not hasattr(d,"result") or self.connector.state != "connected" or \
               not isinstance(d.result,pb.RemoteReference):
           time.sleep(self.sleeptime)
       self.remote = d.result
   def GetInfo(self):
       d = self.remote.callRemote("info")
       d.addCallback(lambda result: result)
       reactor.callInThread(reactor.wakeUp)
       while not hasattr(d,"result"): time.sleep(self.sleeptime)
       self.hubinfo = d.result
       while "numrunners" not in self.hubinfo:
          print self.hubinfo
       self.numrunners = self.hubinfo["numrunners"]
       print "Number of runners in the Hub=",self.numrunners
   def Start(self):
       self.Connect()
       self.GetInfo()
       self.Listening()
       while not hasattr(self,"listen"):
         print "Waiting for listener."
         time.sleep(self.sleeptime)
       reactor.callInThread(self.Scan)
       reactor.callInThread(reactor.wakeUp)
   def Send(self):
       if (self.tasks and self.tasks[0] not in self.queued) and len(self.queued) < self.numrunners:
           otask = self.tasks[0]
           self.tasks.remove(otask)
           self.queued.append(otask)
           reactor.callInThread(self.Dispatch,otask)
   def Scan(self):
       self.queued = []
       nr = 0
       ws = task.LoopingCall(self.Send)
       ws.start(self.sleeptime)
       while self.tasks:
          reactor.callFromThread(reactor.wakeUp)
          nr += 1
          time.sleep(self.sleeptime)
          if self.verb and not (nr%40):  print len(self.tasks),len(self.queued)
       ws.stop()
       reactor.callFromThread(reactor.wakeUp)
       while self.queued:
          time.sleep(self.sleeptime)
       reactor.callFromThread(reactor.disconnectAll)
       reactor.callFromThread(reactor.stop)
   def Listening(self,otask=None):
       realm = TaskRealm(self)
       portal = Portal(realm)
       checker = InMemoryUsernamePasswordDatabaseDontUse()
       if self.user:
          checker.addUser(self.user,self.password)
       else:
          c = checker.addUser("anonymous","anonymous")
       portal.registerChecker(checker)
       listen = reactor.listenTCP(0, pb.PBServerFactory( portal))
       listen.startListening()
       reactor.callFromThread(reactor.wakeUp)
       if otask:
          otask.listen = listen
          otask.ohost = otask.listen.getHost().host
          otask.port = otask.listen.getHost().port
       else:
          self.listen = listen
          print "Listening on", self.listen.getHost().host, self.listen.getHost().port
   def Dispatch(self,otask):
       if hasattr(self,"listen"):
          otask.ohost = self.listen.getHost().host
          otask.port = self.listen.getHost().port
       else:
          self.Listening(otask)
       ctask = CopyTask()
       for attr in otask.elements:
          if getattr(otask,attr):
             setattr(ctask,attr,getattr(otask,attr))
       d = self.remote.callRemote("task",ctask)
       d.addErrback(lambda reason: reason.value)
       d.addCallback(lambda result: result)
       if not hasattr(d,"result"):
            time.sleep(self.sleeptime)
       if self.verb: print "Sent",otask.taskid
       if "reactor.stop" not in otask.func and not otask.done:
          while not otask.done: time.sleep(self.sleeptime)
       if self.verb: print "Got the result for task",otask.taskid
       self.completed.append(otask)
       self.queued.remove(otask)
       if hasattr(otask,"listen"): otask.listen.stopListening()

def AddManhole(user,password,namespace,port):
    checker = InMemoryUsernamePasswordDatabaseDontUse()
    checker.addUser(user,password)
    rlm = TerminalRealm()
    rlm.chainedProtocolFactory = lambda: insults.ServerProtocol( Manhole,namespace=namespace)
    ptl = Portal(rlm, [checker])
    f = ConchFactory(ptl)
    r = reactor.listenTCP(port, f)
    return r.getHost().port

class SpawnTask(pb.Avatar):
   def __init__(self,add_modules=[],add_fmodules=[]):
      self.added = []
      self.fadded = []
      self.modules = []
      self.fmodules = ["Numeric"]
      if add_modules.split(","): self.modules += add_modules.split(",")
      if add_fmodules.split(","): self.fmodules += add_fmodules.split(",")
   def perspective_lmod(self,smod):
         lmod = cPickle.loads(smod)
         os.chdir(lmod["path"])
         f = open(lmod["name"],"w")
         f.write(lmod["data"])
         f.close()
   def perspective_task(self,otask):
      tstart = time.time()
      print "Got",otask
      sys.stdout.flush()
      try:
         loadavg = os.getloadavg()
         func = otask.func
         taskid = otask.taskid
         sys.stdout.write("Function=%s\n" % (func))
         sys.stdout.flush()
         path = otask.path
         print "Changing current working directory to %s." % (path)
         sys.stdout.flush()
         os.chdir(path)
         sys.path = orig_path + [path]
         sys.stdout.flush()
         if hasattr(otask,"env"):
            newenviron = cPickle.loads(otask.env)
            print "Loading environment variables."
            for item in newenviron:
                os.environ[item] = newenviron[item]
         if hasattr(otask,"modules"):
            [twisted_import(m) for m in otask.modules if m]
         if hasattr(otask,"fmodules"):
            [twisted_import(m,"*") for m in otask.fmodules if m]
         if self.modules:
            [(twisted_import(m),self.added.append(m)) for m in self.modules if m and m not in self.added]
         if self.fmodules:
            [(twisted_import(m,"*"),self.fadded.append(m)) for m in self.fmodules if m and m not in self.fadded]
         value = TestTask(otask)
         value = cPickle.dumps(value)
         pickled = True
         sys.stdout.write("Task %r completed.\n" % (taskid))
         sys.stdout.flush()
      except:
         content = sys.stdout = sys.stderr = cStringIO.StringIO()
         traceback.print_exc()
         sys.stdout = sys.__stdout__
         sys.stderr = sys.__stderr__
         pickled = False
         value = content.getvalue()
         sys.stderr.write(value)
         sys.stderr.flush()
      if hasattr(otask,"cleanup"): eval(otask.cleanup)()
      tnow = time.time()
      telapse = tnow-tstart
      output = (loadavg,taskid,value,pickled)
      return output

class FunctionRealm:
    implements(IRealm)
    def __init__(self,modules,fmodules):
       self.modules = modules
       self.fmodules = fmodules
       self.functionSpawn = SpawnTask(self.modules,self.fmodules)
    def requestAvatar(self, avatarId, mind, *interfaces):
        if pb.IPerspective in interfaces:
            return pb.IPerspective, self.functionSpawn, lambda : None
        else:
            raise NotImplementedError("no interface")

def CleanMachines(machines,uid=getpass.getuser()):
    machines = list(sets.Set(machines))
    return TwistedHub([],verb=0,clean=1,wait=0,norun=1,machines=machines,uid=uid,namespace=globals(),nice=0)


