#!/usr/local/bin/python

from Numeric import *
from umath import *
from pgplot import *
from string import *
from sys import argv,exit
from ephem import *
from masks import rd2xy,readsoln,xy2rd

wf_field = 75.0

def mkccd(xc,yc,wid,ct,st,ci=1,ls=1,lw=1,rat=1, sky=None):
  xtop = 0.0; xbot = 0.0
  xlef = wid; xrig = -wid
  ytop = -wid; ybot = wid
  ylef = 0.0; yrig = 0.0

  x1 = xc + (xlef*ct + ylef*st) + (rat-1)*xlef*ct - (rat-1)*xlef*st
  y1 = yc + (xlef*st - ylef*ct) + (rat-1)*xlef*ct + (rat-1)*xlef*st

  x2 = xc + (xbot*ct + ybot*st) - (rat-1)*xlef*ct + (rat-1)*xlef*st
  y2 = yc + (xbot*st - ybot*ct) - (rat-1)*xlef*ct - (rat-1)*xlef*st

  x3 = xc + (xrig*ct + yrig*st) + (rat-1)*xrig*ct - (rat-1)*xrig*st
  y3 = yc + (xrig*st - yrig*ct) + (rat-1)*xrig*ct + (rat-1)*xrig*st
                                                                    
  x4 = xc + (xtop*ct + ytop*st) - (rat-1)*xrig*ct + (rat-1)*xrig*st
  y4 = yc + (xtop*st - ytop*ct) - (rat-1)*xrig*ct - (rat-1)*xrig*st

  x=array([x1,x2,x3,x4,x1],Float32)
  y=array([y1,y2,y3,y4,y1],Float32)
  if sky:
     x,y = xy2rd(sky,x,y,text=0)
     x = x*180/pi/15 * 3600
     y = y*180/pi * 3600
  drawslit(x,y,ci=ci,lw=lw,ls=ls)

def footprint( foots, astro, ainfo=None, sky=None):

	g=open(foots,"r")
	gl=g.readlines()
	g.close()

	if astro:
	  z1 = float(split(gl[0])[0])
	  z2 = float(split(gl[0])[1])
	  ci = int(split(gl[0])[2])
	  lw = 1
	  dev = split(gl[0])[3]
	  nf=len(gl)
	  if nf > 1: winfo = map(lambda l: split(l), gl[1:])
	  fty=map(lambda f: float(f[0]), winfo)
	  rap=array(map(lambda f: hrrad(scanSexagesimal(f[1])), winfo))
	  decp=array(map(lambda f: degrad(scanSexagesimal(f[2])), winfo))
	  fpa=map(lambda f: float(f[3]), winfo)
	  fmisc=map(lambda f: f[4], winfo)
	  fci=map(lambda f: int(float(f[5])), winfo)
	  flw=map(lambda f: int(float(f[6])), winfo)
          if dev[-2:] == "ps":
              fls = fci
              fci = len(fci)*[1]
          else:
              fls = len(fci)*[1]
          pt=[]
          for wf in winfo:
            if wf[7:]: ptarg=float(wf[7]),float(wf[8])
            else: ptarg=0.0,0.0
            pt.append( ptarg)
	  if not ainfo:
             soln = readsoln(astro)
             ainfo=[[len(soln["c"]),0, soln["center"][0], soln["center"][1]]]
             ainfo+=[[soln["sky"][0], soln["sky"][1]]]
             for c in soln["c"]: ainfo+=[c]
	  if 0:
	     ad=open(astro,"r")
	     adl=ad.readlines()
	     ad.close()
#	     ainfo = map(lambda l: map(lambda s: float(s), split(l)), adl)
	     ainfo = map(lambda l: split(l), adl)
#	     ainfo = map(lambda l: map(float,l), ainfo)
             for ain in range(len(ainfo)):
                for ajn in range(len(ainfo[ain])):
                   if ainfo[ain][ajn] == "|": ainfo[ain][ajn] = 0
                ainfo[ain]=map(float,ainfo[ain])
	  xfm = array(transpose(ainfo[2:])[0])
	  nxfm = len(xfm)
	  x0, y0 = ainfo[0][2], ainfo[0][3]
	  ra0, dec0 = ainfo[1][0], ainfo[1][1]
	  xp, yp, imscale, impa = rd2xy( astro, rap, decp)
          impa = raddeg(impa)
          def postarg( pt, fpa, xp, yp, impa,imscale, dz):
               xs = (pt[0]*cos( degrad(fpa-impa+dz)) - pt[1]*sin( degrad(fpa+impa+dz)))/imscale
               ys = (pt[0]*sin( degrad(fpa-impa+dz)) + pt[1]*cos( degrad(fpa+impa+dz)))/imscale
               return xp-xs,yp-ys
	  for n in range(len(fmisc)):
	    if fmisc[n][:5] == 'WFALL':
#               drawpt1( xp[n],yp[n],ps=0,ci=fci[n])
               xp[n],yp[n]=postarg(pt[n],fpa[n],xp[n],yp[n],impa,imscale,45)
#               drawpt1( xp[n],yp[n],ps=5,ci=fci[n])
	       d=(wf_field*sqrt(2)/2)/imscale - 16.0/imscale
	       xs = d*sin( degrad(fpa[n]-impa))
	       ys = -d*cos( degrad(fpa[n]-impa))
	       xp[n],yp[n]=xp[n]+xs,yp[n]+ys
	    elif fmisc[n][:3] == 'WF3':
               drawpt1( xp[n],yp[n],ps=5,ci=fci[n])
	       d=0.05*(wf_field/sqrt(2))/imscale
	       xs = -d*cos( degrad(fpa[n]-impa))
	       ys = -d*sin( degrad(fpa[n]-impa))
	       xp[n],yp[n]=xp[n]+xs,yp[n]+ys
	       xs = -d*sin( degrad(fpa[n]-impa))
	       ys = -d*cos( degrad(fpa[n]-impa))
	       xp[n],yp[n]=xp[n]+xs,yp[n]+ys
	    elif fmisc[n][:3] == 'WF2':
               drawpt1( xp[n],yp[n],ps=5,ci=fci[n])
	       d=0.95*(wf_field/sqrt(2))/imscale
	       xs = d*cos( degrad(fpa[n]-impa))
	       ys = d*sin( degrad(fpa[n]-impa))
	       xp[n],yp[n]=xp[n]+xs,yp[n]+ys
	       xs = d*sin( degrad(fpa[n]-impa))
	       ys = -d*cos( degrad(fpa[n]-impa))
	       xp[n],yp[n]=xp[n]+xs,yp[n]+ys
	  finfo = transpose([fty, xp, yp, fpa]).tolist()
	  for n in range(len(fmisc)):
	     if winfo[n][5:]: finfo[n]= finfo[n]+ winfo[n][5:]
	else:
	  imscale = float(split(gl[0])[0])
	  impa = float(split(gl[0])[1])
	  z1 = float(split(gl[1])[0])
	  z2 = float(split(gl[1])[1])
	  ci = int(split(gl[1])[2])
	  lw = 1
	  dev = split(gl[1])[3]
	  nf=len(gl)
	  if nf > 2: finfo = map(lambda l: map(lambda s: float(s), split(l)), gl[2:])

	for fo in finfo:

	 if len(fo):
          if len(fci): ci=fci[finfo.index(fo)]
          if len(fls): ls=fls[finfo.index(fo)]
          if len(flw): lw=flw[finfo.index(fo)]

	  if fo[0] == 0:
	   xc=fo[1]; yc=fo[2]; th = (fo[3]-impa)*pi/180
	   ct = cos(th); st=sin(th)
	   wl = (wf_field/imscale)
	   mkccd(xc,yc,wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   mkccd(xc+wl*(ct-st)/sqrt(2),yc+wl*(ct+st)/sqrt(2),wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   mkccd(xc+wl*(-ct-st)/sqrt(2),yc+wl*(ct-st)/sqrt(2),wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   xn=xc + wl*(-ct-st)/sqrt(2) + wl/sqrt(2)*ct - wl/sqrt(2)*st
	   yn=yc + wl*(ct-st)/sqrt(2) + wl/sqrt(2)*st + wl/sqrt(2)*ct
	   mkccd(xn,yn,wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)

	  elif int(fo[0]) == 1:
	   xc=fo[1]; yc=fo[2]; th = (fo[3]-impa)*pi/180
	   ct = cos(th); st=sin(th)
	   wl = (wf_field/imscale)
#	   pl = wl*(0.035/0.10)
	   pl = wl*(0.0316/0.10)
	   mkccd(xc,yc,wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   mkccd(xc+wl*(ct-st)/sqrt(2),yc+wl*(ct+st)/sqrt(2),wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   mkccd(xc+wl*(-ct-st)/sqrt(2),yc+wl*(ct-st)/sqrt(2),wl/sqrt(2),ct,st,ci,ls,lw, sky=sky)
	   xn=xc + wl*(-ct-st)/sqrt(2) + wl/sqrt(2)*ct - pl*st
	   yn=yc + wl*(ct-st)/sqrt(2) + wl/sqrt(2)*st + pl*ct
	   if fo[0] == 1.5: mkccd(xn,yn,pl,ct,st,ci,ls,lw, sky=sky)

	  elif fo[0] == 2:
	   xc=fo[1]; yc=fo[2]; th = (fo[3]-impa-45)*pi/180
	   ct = cos(th); st=sin(th)
	   wl = (205.0/imscale)
	   mkccd(xc,yc,wl/sqrt(2),ct,st,ci,ls,lw,rat=1.00, sky=sky)

	  elif fo[0] == 3:
	   xc=fo[1]; yc=fo[2]; th = (fo[3]-impa+45.0)*pi/180
	   ct = cos(th); st=sin(th)
	   wl = (350.0/imscale)
	   mkccd(xc,yc,wl/sqrt(2),ct,st,ci,ls,lw,rat=1.12, sky=sky)

	return ainfo
